Makefile.flags: restrict Wno-constant-logical-operand and Wno-string-plus-int options...
[oweals/busybox.git] / scripts / trylink
1 #!/bin/sh
2
3 debug=false
4
5 # Linker flags used:
6 #
7 # Informational:
8 # --warn-common
9 # -Map $EXE.map
10 # --verbose
11 #
12 # Optimizations:
13 # --sort-common                 reduces padding
14 # --sort-section alignment      reduces padding
15 # --gc-sections                 throws out unused sections,
16 #                               does not work for shared libs
17 # -On                           Not used, maybe useful?
18 #
19 # List of files to link:
20 # $l_list                       == --start-group -llib1 -llib2 --end-group
21 # --start-group $O_FILES $A_FILES --end-group
22 #
23 # Shared library link:
24 # -shared                       self-explanatory
25 # -fPIC                         position-independent code
26 # --enable-new-dtags            ?
27 # -z,combreloc                  ?
28 # -soname="libbusybox.so.$BB_VER"
29 # --undefined=lbb_main          Seed name to start pulling from
30 #                               (otherwise we'll need --whole-archive)
31 # -static                       Not used, but may be useful! manpage:
32 #                               "... This option can be used with -shared.
33 #                               Doing so means that a shared library
34 #                               is being created but that all of the library's
35 #                               external references must be resolved by pulling
36 #                               in entries from static libraries."
37
38
39 try() {
40     printf "%s\n" "Output of:" >$EXE.out
41     printf "%s\n" "$*" >>$EXE.out
42     printf "%s\n" "==========" >>$EXE.out
43     $debug && echo "Trying: $*"
44     $@ >>$EXE.out 2>&1
45     return $?
46 }
47
48 check_cc() {
49     tempname="$(mktemp tmp.XXXXXXXXXX)"
50     echo "int main(int argc,char**argv){return argv?argc:0;}" >"$tempname".c
51     # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
52     # Was using "-xc /dev/null", but we need a valid C program.
53     $CC $CFLAGS $LDFLAGS $1 "$tempname".c -o "$tempname" >/dev/null 2>&1
54     exitcode=$?
55     rm -f "$tempname" "$tempname".c "$tempname".o
56     return $exitcode
57 }
58
59 check_libc_is_glibc() {
60     tempname="$(mktemp tmp.XXXXXXXXXX)"
61     echo "\
62         #include <stdlib.h>
63         /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
64         #if defined(__GLIBC__) && !defined(__UCLIBC__)
65         syntax error here
66         #endif
67         " >"$tempname".c
68     ! $CC $CFLAGS "$tempname".c -c -o "$tempname".o >/dev/null 2>&1
69     exitcode=$?
70     rm -f "$tempname" "$tempname".c "$tempname".o
71     return $exitcode
72 }
73
74 EXE="$1"
75 CC="$2"
76 CFLAGS="$3"
77 LDFLAGS="$4"
78 O_FILES="$5"
79 A_FILES="$6"
80 LDLIBS="$7"
81
82 # The --sort-section option is not supported by older versions of ld
83 SORT_SECTION="-Wl,--sort-section,alignment"
84 if ! check_cc "-Wl,--sort-section,alignment"; then
85     echo "Your linker does not support --sort-section,alignment"
86     SORT_SECTION=""
87 fi
88
89 START_GROUP="-Wl,--start-group"
90 END_GROUP="-Wl,--end-group"
91 INFO_OPTS() {
92         echo "-Wl,--warn-common -Wl,-Map,$EXE.map -Wl,--verbose"
93 }
94
95 # gold may not support --sort-common (yet)
96 SORT_COMMON="-Wl,--sort-common"
97 if ! check_cc "-Wl,--sort-common"; then
98     echo "Your linker does not support --sort-common"
99     SORT_COMMON=""
100 fi
101
102 # Static linking against glibc produces buggy executables
103 # (glibc does not cope well with ld --gc-sections).
104 # See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
105 # Note that glibc is unsuitable for static linking anyway.
106 # We are removing -Wl,--gc-sections from link command line.
107 GC_SECTIONS="-Wl,--gc-sections"
108 if (. ./.config && test x"$CONFIG_STATIC" = x"y") then
109     if check_libc_is_glibc; then
110         echo "Static linking against glibc, can't use --gc-sections"
111         GC_SECTIONS=""
112     fi
113 fi
114 # The --gc-sections option is not supported by older versions of ld
115 if test -n "$GC_SECTIONS"; then
116     if ! check_cc "$GC_SECTIONS"; then
117         echo "Your linker does not support $GC_SECTIONS"
118         GC_SECTIONS=""
119     fi
120 fi
121
122 # Sanitize lib list (dups, extra spaces etc)
123 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
124
125 # First link with all libs. If it fails, bail out
126 echo "Trying libraries: $LDLIBS"
127 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
128 l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
129 test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
130 try $CC $CFLAGS $LDFLAGS \
131         -o $EXE \
132         $SORT_COMMON \
133         $SORT_SECTION \
134         $GC_SECTIONS \
135         $START_GROUP $O_FILES $A_FILES $END_GROUP \
136         $l_list \
137 || {
138     echo "Failed: $l_list"
139     cat $EXE.out
140     echo 'Note: if build needs additional libraries, put them in CONFIG_EXTRA_LDLIBS.'
141     echo 'Example: CONFIG_EXTRA_LDLIBS="pthread dl tirpc audit pam"'
142     exit 1
143 }
144
145 # Now try to remove each lib and build without it.
146 # Stop when no lib can be removed.
147 while test "$LDLIBS"; do
148     $debug && echo "Trying libraries: $LDLIBS"
149     dropped_non_first_lib=false
150     first_lib=true
151     for one in $LDLIBS; do
152         without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
153         # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
154         l_list=`echo " $without_one " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
155         test x"$l_list" != x"" && l_list="$START_GROUP $l_list $END_GROUP"
156         $debug && echo "Trying -l options: '$l_list'"
157         try $CC $CFLAGS $LDFLAGS \
158                 -o $EXE \
159                 $SORT_COMMON \
160                 $SORT_SECTION \
161                 $GC_SECTIONS \
162                 $START_GROUP $O_FILES $A_FILES $END_GROUP \
163                 $l_list
164         if test $? = 0; then
165             echo " Library $one is not needed, excluding it"
166             LDLIBS="$without_one"
167             $first_lib || dropped_non_first_lib=true
168         else
169             echo " Library $one is needed, can't exclude it (yet)"
170             first_lib=false
171         fi
172     done
173     # We can stop trying to drop libs if either all libs were needed,
174     # or we excluded only the _first_ few.
175     # (else: we dropped some intermediate lib(s), maybe now we can succeed
176     # in dropping some of the preceding ones)
177     $dropped_non_first_lib || break
178 done
179
180 # Make the binary with final, minimal list of libs
181 echo "Final link with: ${LDLIBS:-<none>}"
182 l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
183 test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
184 # --verbose gives us gobs of info to stdout (e.g. linker script used)
185 if ! test -f busybox_ldscript; then
186     try $CC $CFLAGS $LDFLAGS \
187             -o $EXE \
188             $SORT_COMMON \
189             $SORT_SECTION \
190             $GC_SECTIONS \
191             $START_GROUP $O_FILES $A_FILES $END_GROUP \
192             $l_list \
193             `INFO_OPTS` \
194     || {
195         cat $EXE.out
196         exit 1
197     }
198 else
199     echo "Custom linker script 'busybox_ldscript' found, using it"
200     # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
201     #  .rodata         : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
202     #  *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
203     #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
204     # This will eliminate most of the padding (~3kb).
205     # Hmm, "ld --sort-section alignment" should do it too.
206     #
207     # There is a ld hack which is meant to decrease disk usage
208     # at the cost of more RAM usage (??!!) in standard ld script:
209     #  /* Adjust the address for the data segment.  We want to adjust up to
210     #     the same address within the page on the next page up.  */
211     #  . = ALIGN (0x1000) - ((0x1000 - .) & (0x1000 - 1)); . = DATA_SEGMENT_ALIGN (0x1000, 0x1000);
212     # Replace it with:
213     #  . = ALIGN (0x1000); . = DATA_SEGMENT_ALIGN (0x1000, 0x1000);
214     # to unconditionally align .data to the next page boundary,
215     # instead of "next page, plus current offset in this page"
216     try $CC $CFLAGS $LDFLAGS \
217             -o $EXE \
218             $SORT_COMMON \
219             $SORT_SECTION \
220             $GC_SECTIONS \
221             -Wl,-T,busybox_ldscript \
222             $START_GROUP $O_FILES $A_FILES $END_GROUP \
223             $l_list \
224             `INFO_OPTS` \
225     || {
226         cat $EXE.out
227         exit 1
228     }
229 fi
230
231 . ./.config
232
233 sharedlib_dir="0_lib"
234
235 if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
236     mkdir "$sharedlib_dir" 2>/dev/null
237     test -d "$sharedlib_dir" || {
238         echo "Cannot make directory $sharedlib_dir"
239         exit 1
240     }
241     ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
242
243     # Yes, "ld -shared -static" is a thing. It's a shared library which is itself static.
244     LBB_STATIC=""
245     test "$CONFIG_FEATURE_LIBBUSYBOX_STATIC" = y && LBB_STATIC="-Wl,-static"
246
247     EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
248     try $CC $CFLAGS $LDFLAGS \
249             -o $EXE \
250             -shared -fPIC $LBB_STATIC \
251             -Wl,--enable-new-dtags \
252             -Wl,-z,combreloc \
253             -Wl,-soname="libbusybox.so.$BB_VER" \
254             -Wl,--undefined=lbb_main \
255             $SORT_COMMON \
256             $SORT_SECTION \
257             $START_GROUP $A_FILES $END_GROUP \
258             $l_list \
259             `INFO_OPTS` \
260     || {
261         echo "Linking $EXE failed"
262         cat $EXE.out
263         exit 1
264     }
265     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
266     chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
267     echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
268 fi
269
270 if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
271     EXE="$sharedlib_dir/busybox_unstripped"
272     try $CC $CFLAGS $LDFLAGS \
273             -o $EXE \
274             $SORT_COMMON \
275             $SORT_SECTION \
276             $GC_SECTIONS \
277             $START_GROUP $O_FILES $END_GROUP \
278             -L"$sharedlib_dir" -lbusybox \
279             $l_list \
280             `INFO_OPTS` \
281     || {
282         echo "Linking $EXE failed"
283         cat $EXE.out
284         exit 1
285     }
286     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
287     echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
288 fi
289
290 if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
291     echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
292     gcc -DNAME_MAIN -E -include include/autoconf.h include/applets.h \
293     | grep -v "^#" \
294     | grep -v "^ *$" \
295     > applet_lst.tmp
296     while read name main junk; do
297
298         echo "\
299 void lbb_prepare(const char *applet, char **argv);
300 int $main(int argc, char **argv);
301
302 int main(int argc, char **argv)
303 {
304         lbb_prepare(\"$name\", argv);
305         return $main(argc, argv);
306 }
307 " >"$sharedlib_dir/applet.c"
308
309         EXE="$sharedlib_dir/$name"
310         try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
311                 -o $EXE \
312                 $SORT_COMMON \
313                 $SORT_SECTION \
314                 $GC_SECTIONS \
315                 -L"$sharedlib_dir" -lbusybox \
316                 -Wl,--warn-common \
317         || {
318             echo "Linking $EXE failed"
319             cat $EXE.out
320             exit 1
321         }
322         rm -- "$sharedlib_dir/applet.c" $EXE.out
323         $STRIP -s --remove-section=.note --remove-section=.comment $EXE
324         # Let user see that we do something - list the names of created binaries:
325         echo "$EXE"
326
327     done <applet_lst.tmp
328 fi
329
330 # libbusybox.so is needed only for -lbusybox at link time,
331 # it is not needed at runtime. Deleting to reduce confusion.
332 rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
333 exit 0 # or else we may confuse make